<template>
  <div>
    <rui-accordion no-content>
      <template #header>
        <label>
          <input v-model="inputs.generic"
                 type="checkbox"
                 name="generic">
          {{ $t('activerecord.attributes.resource.generic') }}
        </label>
      </template>
    </rui-accordion>

    <rui-accordion icon="tag" :caption="$t('activerecord.attributes.resource.tag_list')">
      <gpa-tag-filters v-model="inputs.tags" />
    </rui-accordion>

    <rui-accordion icon="calendar" :caption="$t('js.library.filters.sheltered_sowing_months')">
      <gp-months-flags-input v-model="inputs.shelteredSowingMonths"
                             format="integers"
                             input-name="sheltered_sowing_months"
                             vertical
                             full-months />
    </rui-accordion>

    <rui-accordion icon="calendar" :caption="$t('js.library.filters.soil_sowing_months')">
      <gp-months-flags-input v-model="inputs.soilSowingMonths"
                             format="integers"
                             input-name="soil_sowing_months"
                             vertical
                             full-months />
    </rui-accordion>

    <rui-accordion icon="calendar" :caption="$t('js.library.filters.harvesting_months')">
      <gp-months-flags-input v-model="inputs.harvestingMonths"
                             format="integers"
                             input-name="harvesting_months"
                             vertical
                             full-months />
    </rui-accordion>

    <rui-accordion icon="refresh" :caption="$t('js.library.filters.crop_rotations')">
      <label v-for="group in cropRotationGroups" :key="group" class="rui-field">
        <input v-model="inputs.cropRotationGroups" type="checkbox" name="crop_rotations[]" :value="group">
        {{ $t(`activerecord.attributes.resource/crop_rotation_group.${group}`) }}
      </label>
    </rui-accordion>
  </div>
</template>

<script>
import { RESOURCE_CROP_ROTATION_GROUPS } from '../../../../../helpers/constants.js'

import RuiAccordion from '@experiments-labs/rise_ui/src/components/DataDisplay/Accordion/Accordion.vue'

import GpMonthsFlagsInput from '../../../../common/Inputs/MonthsFlags/MonthsFlags.vue'
import GpaTagFilters from '../Tags/TagFilters.vue'

export default {
  name: 'GpaLibraryFilters',
  emits: [
    'update:modelValue',
  ],
  components: { RuiAccordion, GpaTagFilters, GpMonthsFlagsInput },
  props: {
    modelValue: {
      required: true,
      type: Object,
      validate: (val) => {
        const keys = Object.keys(val)
        for (const k of ['generic', 'harvestingMonths', 'shelteredSowingMonths', 'soilSowingMonths', 'tags', 'cropRotationGroups']) {
          if (!keys.includes(k)) return false
        }
        return true
      },
    },
  },
  data () {
    return {
      cropRotationGroups: RESOURCE_CROP_ROTATION_GROUPS,
      inputs: {
        generic: false,
        tags: [],
        shelteredSowingMonths: [],
        soilSowingMonths: [],
        harvestingMonths: [],
        cropRotationGroups: [],
      },
    }
  },
  methods: {
    setInputValues () {
      this.inputs.generic = this.$props.modelValue.generic
      this.inputs.tags = this.$props.modelValue.tags
      this.inputs.shelteredSowingMonths = this.$props.modelValue.shelteredSowingMonths
      this.inputs.soilSowingMonths = this.$props.modelValue.soilSowingMonths
      this.inputs.harvestingMonths = this.$props.modelValue.harvestingMonths
      this.inputs.cropRotationGroups = this.$props.modelValue.cropRotationGroups
    },
    outputValues () {
      return {
        generic: this.inputs.generic,
        tags: this.inputs.tags,
        shelteredSowingMonths: this.inputs.shelteredSowingMonths,
        soilSowingMonths: this.inputs.soilSowingMonths,
        harvestingMonths: this.inputs.harvestingMonths,
        cropRotationGroups: this.inputs.cropRotationGroups,
      }
    },
  },
  created () {
    this.setInputValues()
  },
  watch: {
    // External changes
    modelValue: {
      handler () { this.setInputValues() },
      deep: true,
    },
    // Internal changes
    'inputs.generic' (newValue) {
      if (newValue === this.$props.modelValue.generic) return
      this.$emit('update:modelValue', this.outputValues())
    },
    'inputs.tags' (newValue) {
      if (newValue.toString() === this.$props.modelValue.tags.toString()) return
      this.$emit('update:modelValue', this.outputValues())
    },
    'inputs.shelteredSowingMonths' (newValue) {
      if (newValue.toString() === this.$props.modelValue.shelteredSowingMonths.toString()) return
      this.$emit('update:modelValue', this.outputValues())
    },
    'inputs.soilSowingMonths' (newValue) {
      if (newValue.toString() === this.$props.modelValue.soilSowingMonths.toString()) return
      this.$emit('update:modelValue', this.outputValues())
    },
    'inputs.harvestingMonths' (newValue) {
      if (newValue.toString() === this.$props.modelValue.harvestingMonths.toString()) return
      this.$emit('update:modelValue', this.outputValues())
    },
    'inputs.cropRotationGroups' (newValue) {
      if (newValue.toString() === this.$props.modelValue.cropRotationGroups.toString()) return
      this.$emit('update:modelValue', this.outputValues())
    },
  },
}
</script>
